Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/Aggregator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/Aggregator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/Aggregator.cs	(revision 16573)
@@ -7,9 +7,10 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
 
   [Item("Aggregator", "Base class of aggreagtors that aggregate results collected from several trajectories.")]
-  [StorableClass]
+  [StorableType("9C6131AD-6544-4792-9223-9DABA3E52074")]
   public abstract class Aggregator<T> : NamedItem, IAggregator where T : class, IItem {
 
@@ -20,5 +21,5 @@
 
     [StorableConstructor]
-    protected Aggregator(bool deserializing) : base(deserializing) { }
+    protected Aggregator(StorableConstructorFlag _) : base(_) { }
     protected Aggregator(Aggregator<T> original, Cloner cloner)
       : base(original, cloner) {
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/AutoCorrelationAggregator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/AutoCorrelationAggregator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/AutoCorrelationAggregator.cs	(revision 16573)
@@ -12,13 +12,14 @@
 using System.Drawing;
 using HeuristicLab.Analysis.FitnessLandscape.Analysis;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
 
   [Item("Auto Correlation Aggregator", "Aggregates auto correlation analyses.")]
-  [StorableClass]
+  [StorableType("969A27FA-5E06-4945-BCA2-87FD869F02A4")]
   public class AutoCorrelationAggregator : Aggregator<AutoCorrelationTable> {
 
     [StorableConstructor]
-    protected AutoCorrelationAggregator(bool deserializing) : base(deserializing) { }
+    protected AutoCorrelationAggregator(StorableConstructorFlag _) : base(_) { }
     protected AutoCorrelationAggregator(AutoCorrelationAggregator original, Cloner cloner) : base(original, cloner) { }
     public AutoCorrelationAggregator() { }
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/BoundingBoxAggregator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/BoundingBoxAggregator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/BoundingBoxAggregator.cs	(revision 16573)
@@ -6,13 +6,14 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
 
   [Item("BoundingBox Aggregator", "Aggregates bounding boxes")]
-  [StorableClass]
+  [StorableType("E6E3FEEA-AEA5-4B6B-87CF-A0AFEF26D9FD")]
   public class BoundingBoxAggregator : Aggregator<DoubleMatrix> {
 
     [StorableConstructor]
-    protected BoundingBoxAggregator(bool deserializing) : base(deserializing) { }
+    protected BoundingBoxAggregator(StorableConstructorFlag _) : base(_) { }
     protected BoundingBoxAggregator(BoundingBoxAggregator original, Cloner cloner) : base(original, cloner) { }
     public BoundingBoxAggregator() { }
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/EvolvabilityAggregator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/EvolvabilityAggregator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/EvolvabilityAggregator.cs	(revision 16573)
@@ -9,9 +9,10 @@
 using HeuristicLab.Data;
 using HeuristicLab.Common.Resources;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
 
   [Item("Evolvability Aggregator", "Aggregates evolvability values into an evolvability portrait.")]
-  [StorableClass]
+  [StorableType("B1471271-C89E-47A9-A0A1-4F0D64468F39")]
   public class EvolvabilityAggregator : NamedItem, IAggregator {
 
@@ -40,5 +41,5 @@
     #region Construction and Cloning
     [StorableConstructor]
-    protected EvolvabilityAggregator(bool deserializing) : base(deserializing) { }
+    protected EvolvabilityAggregator(StorableConstructorFlag _) : base(_) { }
     protected EvolvabilityAggregator(EvolvabilityAggregator original, Cloner cloner)
       : base(original, cloner) {
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/InformationAnalysisAggregator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/InformationAnalysisAggregator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/InformationAnalysisAggregator.cs	(revision 16573)
@@ -8,13 +8,14 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
 
   [Item("InformationAnalysis Aggregator", "Aggregates information anlyses.")]
-  [StorableClass]
+  [StorableType("30A0DDD6-CF94-4061-95C2-5717617EB7C1")]
   public class InformationAnalysisAggregator : Aggregator<InformationAnalysisTable> {
 
     [StorableConstructor]
-    protected InformationAnalysisAggregator(bool deserializing) : base(deserializing) { }
+    protected InformationAnalysisAggregator(StorableConstructorFlag _) : base(_) { }
     protected InformationAnalysisAggregator(InformationAnalysisAggregator original, Cloner cloner) : base(original, cloner) { }
     public InformationAnalysisAggregator() { }
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/InformationAnalysisPeakAggregator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/InformationAnalysisPeakAggregator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/InformationAnalysisPeakAggregator.cs	(revision 16573)
@@ -9,13 +9,14 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Data;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
 
   [Item("InformationAnalysis Peak Aggregator", "Aggregates peak information anlyses.")]
-  [StorableClass]
+  [StorableType("BDB8568B-EBF5-437C-81C2-C68F77C3FCEF")]
   public class InformationAnalysisPeakAggregator : Aggregator<InformationAnalysisTable> {
 
     [StorableConstructor]
-    protected InformationAnalysisPeakAggregator(bool deserializing) : base(deserializing) { }
+    protected InformationAnalysisPeakAggregator(StorableConstructorFlag _) : base(_) { }
     protected InformationAnalysisPeakAggregator(InformationAnalysisPeakAggregator original, Cloner cloner) : base(original, cloner) { }
     public InformationAnalysisPeakAggregator() { }
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/InformationAnalysisValueAggregator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/InformationAnalysisValueAggregator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/InformationAnalysisValueAggregator.cs	(revision 16573)
@@ -10,9 +10,10 @@
 using HeuristicLab.Data;
 using HeuristicLab.Common.Resources;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
 
   [Item("InformationAnalysisValue Aggregator", "Aggregates information anlysis values.")]
-  [StorableClass]
+  [StorableType("829CDE87-6290-42AE-93EF-5095B52AD6FF")]
   public class InformationAnalysisValueAggregator : NamedItem, IAggregator {
 
@@ -35,5 +36,5 @@
     #region Construction and Cloning
     [StorableConstructor]
-    protected InformationAnalysisValueAggregator(bool deserializing) : base(deserializing) { }
+    protected InformationAnalysisValueAggregator(StorableConstructorFlag _) : base(_) { }
     protected InformationAnalysisValueAggregator(InformationAnalysisValueAggregator original, Cloner cloner)
       : base(original, cloner) {
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/InformationStabilityAggregator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/InformationStabilityAggregator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/InformationStabilityAggregator.cs	(revision 16573)
@@ -12,13 +12,14 @@
 using System.Drawing;
 using HeuristicLab.Analysis.FitnessLandscape.Analysis;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
 
   [Item("Information Stability Aggregator", "Aggregates information stability analyses.")]
-  [StorableClass]
+  [StorableType("0E2319B7-EB74-4363-A89F-26A3517CB7F7")]
   public class InformationStabilityAggregator : Aggregator<InformationStabilityTable> {
 
     [StorableConstructor]
-    protected InformationStabilityAggregator(bool deserializing) : base(deserializing) { }
+    protected InformationStabilityAggregator(StorableConstructorFlag _) : base(_) { }
     protected InformationStabilityAggregator(InformationStabilityAggregator original, Cloner cloner) : base(original, cloner) { }
     public InformationStabilityAggregator() { }
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/QualityTrailSummaryAggregator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/QualityTrailSummaryAggregator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/QualityTrailSummaryAggregator.cs	(revision 16573)
@@ -5,13 +5,14 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
 
   [Item("QualityTrailSummary Aggregator", "Aggregates quality trail summaries.")]
-  [StorableClass]
+  [StorableType("B07DD0C5-AAA2-46C4-8BF2-64EB07951985")]
   public class QualityTrailSummaryAggregator : Aggregator<QualityTrailSummaryTable> {
 
     [StorableConstructor]
-    protected QualityTrailSummaryAggregator(bool deserializing) : base(deserializing) { }
+    protected QualityTrailSummaryAggregator(StorableConstructorFlag _) : base(_) { }
     protected QualityTrailSummaryAggregator(QualityTrailSummaryAggregator original, Cloner cloner) : base(original, cloner) { }
     public QualityTrailSummaryAggregator() { }
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/RuggednessAggregator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/RuggednessAggregator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/RuggednessAggregator.cs	(revision 16573)
@@ -12,9 +12,10 @@
 using System.Drawing;
 using HeuristicLab.Analysis.FitnessLandscape.Analysis;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
 
   [Item("Ruggedness Aggregator", "Aggregates scalar ruggedness analyses.")]
-  [StorableClass]
+  [StorableType("03C63217-F50F-4111-B978-DF83ADC5DDBE")]
   public class RuggednessAggregator : NamedItem, IAggregator {
 
@@ -27,5 +28,5 @@
     #region Construction & Cloning
     [StorableConstructor]
-    protected RuggednessAggregator(bool deserializing) : base(deserializing) { }
+    protected RuggednessAggregator(StorableConstructorFlag _) : base(_) { }
     protected RuggednessAggregator(RuggednessAggregator original, Cloner cloner) : base(original, cloner) {
       autocorrelations = original.autocorrelations.ToList();
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/UpDownAggregatorAggregator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/UpDownAggregatorAggregator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/Aggregators/UpDownAggregatorAggregator.cs	(revision 16573)
@@ -12,9 +12,10 @@
 using System.Drawing;
 using HeuristicLab.Analysis.FitnessLandscape.Analysis;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
 
   [Item("Up Down Aggregator", "Aggregates scalar up down analyses.")]
-  [StorableClass]
+  [StorableType("597E3537-ADE8-4B7A-A34B-AD6AF105493F")]
   public class UpDownAggregator : NamedItem, IAggregator {
 
@@ -33,5 +34,5 @@
     #region Construction & Cloning
     [StorableConstructor]
-    protected UpDownAggregator(bool deserializing) : base(deserializing) { }
+    protected UpDownAggregator(StorableConstructorFlag _) : base(_) { }
     protected UpDownAggregator(UpDownAggregator original, Cloner cloner) : base(original, cloner) {
       downWalkLengths = original.downWalkLengths.ToList();
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/FitnessCloudAnalyzer.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/FitnessCloudAnalyzer.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/FitnessCloudAnalyzer.cs	(revision 16573)
@@ -27,8 +27,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape.Analysis {
 
-  [StorableClass]
+  [StorableType("4156976F-4E61-48BA-B598-FEA872F2E948")]
   public class FitnessCloudAnalyzer : AlgorithmOperator, IQualityTrailAnalyzer {
     public bool EnabledByDefault {
@@ -49,5 +50,5 @@
 
     [StorableConstructor]
-    protected FitnessCloudAnalyzer(bool deserializing) : base(deserializing) { }
+    protected FitnessCloudAnalyzer(StorableConstructorFlag _) : base(_) { }
     protected FitnessCloudAnalyzer(FitnessCloudAnalyzer original, Cloner cloner) : base(original, cloner) { }
 
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/InformationAnalysisCalculator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/InformationAnalysisCalculator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/InformationAnalysisCalculator.cs	(revision 16573)
@@ -6,8 +6,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape.Analysis {
   [Item("InformationAnalysisCalculator", "Performs an information analysis on a quality trail as described in Vassilev et al. (2000) Evol Comput 8:31–60")]
-  [StorableClass]
+  [StorableType("20A6AC5F-6CD1-46B5-B025-0F8C58685918")]
   public class InformationAnalysisCalculator : SingleSuccessorOperator {
 
@@ -50,5 +51,5 @@
     #region Constructors & Cloning
     [StorableConstructor]
-    protected InformationAnalysisCalculator(bool deserializing) : base(deserializing) { }
+    protected InformationAnalysisCalculator(StorableConstructorFlag _) : base(_) { }
     public InformationAnalysisCalculator() {
       Parameters.Add(new LookupParameter<DataTable>("QualityTrail", "Historical quality trail of a walk over a fitness landscape."));
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/InformationAnalyzer.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/InformationAnalyzer.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/InformationAnalyzer.cs	(revision 16573)
@@ -30,8 +30,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape.Analysis {
 
-  [StorableClass]
+  [StorableType("57803A7A-E1A7-4AD8-9F32-D97F5983ACBD")]
   public class InformationAnalyzer : AlgorithmOperator, IQualityTrailAnalyzer {
     public bool EnabledByDefault {
@@ -119,5 +120,5 @@
 
     [StorableConstructor]
-    protected InformationAnalyzer(bool deserializing) : base(deserializing) { }
+    protected InformationAnalyzer(StorableConstructorFlag _) : base(_) { }
     protected InformationAnalyzer(InformationAnalyzer original, Cloner cloner) : base(original, cloner) { }
 
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/NeutralityAnalyzer.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/NeutralityAnalyzer.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/NeutralityAnalyzer.cs	(revision 16573)
@@ -31,9 +31,10 @@
 using HeuristicLab.Optimization;
 using System.Collections.Generic;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape.Analysis {
 
   [Item("Neutrality Analzyer", "Analyzes neutral parts of a trajectory")]
-  [StorableClass]
+  [StorableType("FA1F7D1C-4567-49F2-A977-07AA50A11F50")]
   public class NeutralityAnalyzer : AlgorithmOperator, IAnalyzer {
     public bool EnabledByDefault {
@@ -84,5 +85,5 @@
 
     [StorableConstructor]
-    protected NeutralityAnalyzer(bool deserializing) : base(deserializing) { }
+    protected NeutralityAnalyzer(StorableConstructorFlag _) : base(_) { }
     protected NeutralityAnalyzer(NeutralityAnalyzer original, Cloner cloner) : base(original, cloner) { }
 
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/QualityTrailMultiAnalyzer.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/QualityTrailMultiAnalyzer.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/QualityTrailMultiAnalyzer.cs	(revision 16573)
@@ -31,8 +31,10 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.PluginInfrastructure;
+using HEAL.Attic;
+
 namespace HeuristicLab.Analysis.FitnessLandscape {
 
   [Item("QualityTrailAnalyzer", "An analyzer that creates a quality trail which can be further analyzed by several analyzers.")]
-  [StorableClass]
+  [StorableType("E02FC8FB-85AD-42AB-8E14-EA509579C8BE")]
   public class QualityTrailMultiAnalyzer : CheckedMultiOperator<IQualityTrailAnalyzer>, IAnalyzer {
     public bool EnabledByDefault {
@@ -75,5 +77,5 @@
 
     [StorableConstructor]
-    protected QualityTrailMultiAnalyzer(bool deserializing) : base(deserializing) { }
+    protected QualityTrailMultiAnalyzer(StorableConstructorFlag _) : base(_) { }
     protected QualityTrailMultiAnalyzer(QualityTrailMultiAnalyzer original, Cloner cloner) : base(original, cloner) { }
 
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/QualityTrailSummarizer.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/QualityTrailSummarizer.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/QualityTrailSummarizer.cs	(revision 16573)
@@ -30,8 +30,9 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using System;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape.Analysis {
 
-  [StorableClass]
+  [StorableType("78C1D578-7752-45B4-9174-DF30D38A7E8A")]
   public class QualityTrailSummarizer : AlgorithmOperator, IQualityTrailAnalyzer {
     public bool EnabledByDefault {
@@ -53,5 +54,5 @@
     #region Construction & Cloning
     [StorableConstructor]
-    protected QualityTrailSummarizer(bool deserializing) : base(deserializing) { }
+    protected QualityTrailSummarizer(StorableConstructorFlag _) : base(_) { }
     protected QualityTrailSummarizer(QualityTrailSummarizer original, Cloner cloner) : base(original, cloner) { }
 
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/RealVectorBoundingBoxUpdater.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/RealVectorBoundingBoxUpdater.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/RealVectorBoundingBoxUpdater.cs	(revision 16573)
@@ -10,9 +10,10 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using HeuristicLab.Common;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape {
  
   [Item("RealVectorBoundingBoxUpdater", "Updates a bounding box using a real vector to be enclosed.")]
-  [StorableClass]
+  [StorableType("1EBAC56C-83F0-41C1-8E42-365E7187EA0D")]
   public class RealVectorBoundingBoxUpdater : SingleSuccessorOperator {
 
@@ -39,5 +40,5 @@
 
     [StorableConstructor]
-    protected RealVectorBoundingBoxUpdater(bool deserializing) : base(deserializing) { }
+    protected RealVectorBoundingBoxUpdater(StorableConstructorFlag _) : base(_) { }
     protected RealVectorBoundingBoxUpdater(RealVectorBoundingBoxUpdater original, Cloner cloner)
       : base(original, cloner) {
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/RepeatAggregator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/RepeatAggregator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/RepeatAggregator.cs	(revision 16573)
@@ -9,9 +9,10 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape.Analysis {
 
   [Item("RepeatAggregator", "Aggregates analysis results from repeated runs on the same starting point.")]
-  [StorableClass]
+  [StorableType("1AFD7B2D-E0AF-4E48-9633-4C17A70D323C")]
   public class RepeatAggregator : SingleSuccessorOperator {
 
@@ -24,5 +25,5 @@
     #region Construction & Cloning
     [StorableConstructor]
-    protected RepeatAggregator(bool deserializing) : base(deserializing) { }
+    protected RepeatAggregator(StorableConstructorFlag _) : base(_) { }
     protected RepeatAggregator(RepeatAggregator original, Cloner cloner) : base(original, cloner) { }
     public RepeatAggregator() {
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/RuggednessAnalyzer.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/RuggednessAnalyzer.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/RuggednessAnalyzer.cs	(revision 16573)
@@ -29,8 +29,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape.Analysis {
 
-  [StorableClass]
+  [StorableType("F018AA6C-B392-4D10-8817-D058D7678149")]
   public class RuggednessAnalyzer : AlgorithmOperator, IQualityTrailAnalyzer {
     public bool EnabledByDefault {
@@ -60,5 +61,5 @@
 
     [StorableConstructor]
-    protected RuggednessAnalyzer(bool deserializing) : base(deserializing) { }
+    protected RuggednessAnalyzer(StorableConstructorFlag _) : base(_) { }
     protected RuggednessAnalyzer(RuggednessAnalyzer original, Cloner cloner) : base(original, cloner) { }
 
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/RuggednessCalculator.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/RuggednessCalculator.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/RuggednessCalculator.cs	(revision 16573)
@@ -8,8 +8,9 @@
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 using System.Collections.Generic;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape.Analysis {
   [Item("Ruggedness Calculator", "Calculates ruggedness descriptors froma given quality trail.")]
-  [StorableClass]
+  [StorableType("1739820A-DC44-4371-A912-E44C1DD46940")]
   public class RuggednessCalculator : SingleSuccessorOperator {
 
@@ -29,5 +30,5 @@
     #region Constructors & Cloning
     [StorableConstructor]
-    protected RuggednessCalculator(bool deserializing) : base(deserializing) { }
+    protected RuggednessCalculator(StorableConstructorFlag _) : base(_) { }
     protected RuggednessCalculator(RuggednessCalculator original, Cloner cloner) : base(original, cloner) { }
     public RuggednessCalculator() {
Index: addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/UpDownWalkAnalyzer.cs
===================================================================
--- addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/UpDownWalkAnalyzer.cs	(revision 15691)
+++ addons/HeuristicLab.FitnessLandscapeAnalysis/HeuristicLab.Analysis.FitnessLandscape/Analysis/UpDownWalkAnalyzer.cs	(revision 16573)
@@ -31,8 +31,9 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Analysis.FitnessLandscape.Analysis {
 
-  [StorableClass]
+  [StorableType("0D054A87-A040-4DC5-A722-0952EE96C924")]
   public class UpDownWalkAnalyzer : AlgorithmOperator, IQualityTrailAnalyzer {
     public bool EnabledByDefault {
@@ -80,5 +81,5 @@
 
     [StorableConstructor]
-    protected UpDownWalkAnalyzer(bool deserializing) : base(deserializing) { }
+    protected UpDownWalkAnalyzer(StorableConstructorFlag _) : base(_) { }
     protected UpDownWalkAnalyzer(UpDownWalkAnalyzer original, Cloner cloner) : base(original, cloner) { }
 