Index: addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/BestParameterConfigurationAnalyzer.cs
===================================================================
--- addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/BestParameterConfigurationAnalyzer.cs	(revision 15740)
+++ addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/BestParameterConfigurationAnalyzer.cs	(revision 16574)
@@ -7,4 +7,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.MetaOptimization {
@@ -13,5 +14,5 @@
   /// </summary>
   [Item("BestParameterConfigurationAnalyzer", "")]
-  [StorableClass]
+  [StorableType("9A11F9C1-B076-45BF-9CCB-661989FC4273")]
   public sealed class BestParameterConfigurationAnalyzer : SingleSuccessorOperator, IAnalyzer {
 
@@ -62,5 +63,5 @@
 
     [StorableConstructor]
-    private BestParameterConfigurationAnalyzer(bool deserializing) : base(deserializing) { }
+    private BestParameterConfigurationAnalyzer(StorableConstructorFlag _) : base(_) { }
     private BestParameterConfigurationAnalyzer(BestParameterConfigurationAnalyzer original, Cloner cloner) : base(original, cloner) { }
     public override IDeepCloneable Clone(Cloner cloner) {
Index: addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/PMOBestSolutionHistoryAnalyzer.cs
===================================================================
--- addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/PMOBestSolutionHistoryAnalyzer.cs	(revision 15740)
+++ addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/PMOBestSolutionHistoryAnalyzer.cs	(revision 16574)
@@ -7,4 +7,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.MetaOptimization {
@@ -13,5 +14,5 @@
   /// </summary>
   [Item("PMOBestSolutionHistoryAnalyzer", "")]
-  [StorableClass]
+  [StorableType("7B257F08-ACCC-4FDF-961A-412344994AD1")]
   public sealed class PMOBestSolutionHistoryAnalyzer : SingleSuccessorOperator, IAnalyzer {
 
@@ -50,5 +51,5 @@
 
     [StorableConstructor]
-    private PMOBestSolutionHistoryAnalyzer(bool deserializing) : base(deserializing) { }
+    private PMOBestSolutionHistoryAnalyzer(StorableConstructorFlag _) : base(_) { }
     private PMOBestSolutionHistoryAnalyzer(PMOBestSolutionHistoryAnalyzer original, Cloner cloner) : base(original, cloner) { }
     public override IDeepCloneable Clone(Cloner cloner) {
Index: addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/PMOPopulationDiversityAnalyzer.cs
===================================================================
--- addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/PMOPopulationDiversityAnalyzer.cs	(revision 15740)
+++ addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/PMOPopulationDiversityAnalyzer.cs	(revision 16574)
@@ -7,4 +7,5 @@
 using HeuristicLab.Core;
 using HeuristicLab.Analysis;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.MetaOptimization {
@@ -13,8 +14,8 @@
   /// </summary>
   [Item("PMOPopulationDiversityAnalyzer", "An operator for analyzing the diversity of solutions of Parameter Meta-Optimization.")]
-  [StorableClass]
+  [StorableType("6B841AFF-BEE0-484D-AC84-26368854852A")]
   public sealed class PMOPopulationDiversityAnalyzer : PopulationDiversityAnalyzer<ParameterConfigurationTree> {
     [StorableConstructor]
-    private PMOPopulationDiversityAnalyzer(bool deserializing) : base(deserializing) { }
+    private PMOPopulationDiversityAnalyzer(StorableConstructorFlag _) : base(_) { }
     private PMOPopulationDiversityAnalyzer(PMOPopulationDiversityAnalyzer original, Cloner cloner) : base(original, cloner) { }
     public PMOPopulationDiversityAnalyzer() : base() { }
Index: addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/PMOProblemQualitiesAnalyzer.cs
===================================================================
--- addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/PMOProblemQualitiesAnalyzer.cs	(revision 15740)
+++ addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/PMOProblemQualitiesAnalyzer.cs	(revision 16574)
@@ -8,4 +8,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.MetaOptimization {
@@ -14,5 +15,5 @@
   /// </summary>
   [Item("PMOProblemQualitiesAnalyzer", "")]
-  [StorableClass]
+  [StorableType("4FA7A73F-76D8-4469-B28E-300FB6248B01")]
   public sealed class PMOProblemQualitiesAnalyzer : SingleSuccessorOperator, IAnalyzer {
 
@@ -47,5 +48,5 @@
 
     [StorableConstructor]
-    private PMOProblemQualitiesAnalyzer(bool deserializing) : base(deserializing) { }
+    private PMOProblemQualitiesAnalyzer(StorableConstructorFlag _) : base(_) { }
     private PMOProblemQualitiesAnalyzer(PMOProblemQualitiesAnalyzer original, Cloner cloner) : base(original, cloner) { }
     public override IDeepCloneable Clone(Cloner cloner) {
Index: addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/ReferenceQualityAnalyzer.cs
===================================================================
--- addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/ReferenceQualityAnalyzer.cs	(revision 15740)
+++ addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/ReferenceQualityAnalyzer.cs	(revision 16574)
@@ -7,4 +7,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.MetaOptimization {
@@ -13,5 +14,5 @@
   /// </summary>
   [Item("ReferenceQualityAnalyzer", "")]
-  [StorableClass]
+  [StorableType("4541DFAD-FED9-4639-814A-55C3C7606E8A")]
   public sealed class ReferenceQualityAnalyzer : SingleSuccessorOperator, IAnalyzer {
 
@@ -71,5 +72,5 @@
 
     [StorableConstructor]
-    private ReferenceQualityAnalyzer(bool deserializing) : base(deserializing) { }
+    private ReferenceQualityAnalyzer(StorableConstructorFlag _) : base(_) { }
     private ReferenceQualityAnalyzer(ReferenceQualityAnalyzer original, Cloner cloner) : base(original, cloner) { }
     public override IDeepCloneable Clone(Cloner cloner) {
Index: addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/SolutionCacheAnalyzer.cs
===================================================================
--- addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/SolutionCacheAnalyzer.cs	(revision 15740)
+++ addons/HeuristicLab.MetaOptimization/HeuristicLab.Problems.MetaOptimization/3.3/Analyzers/SolutionCacheAnalyzer.cs	(revision 16574)
@@ -7,4 +7,5 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HEAL.Attic;
 
 namespace HeuristicLab.Problems.MetaOptimization {
@@ -13,5 +14,5 @@
   /// </summary>
   [Item("SolutionCacheAnalyzer", "")]
-  [StorableClass]
+  [StorableType("0D06B2C3-DA06-47B3-AA1C-6BF491173504")]
   public sealed class SolutionCacheAnalyzer : SingleSuccessorOperator, IAnalyzer {
 
@@ -50,5 +51,5 @@
 
     [StorableConstructor]
-    private SolutionCacheAnalyzer(bool deserializing) : base(deserializing) { }
+    private SolutionCacheAnalyzer(StorableConstructorFlag _) : base(_) { }
     private SolutionCacheAnalyzer(SolutionCacheAnalyzer original, Cloner cloner) : base(original, cloner) { }
     public override IDeepCloneable Clone(Cloner cloner) {