Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.cs	(revision 16585)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Symbolic.Views/3.4/InteractiveSymbolicDataAnalysisSolutionSimplifierView.cs	(revision 16586)
@@ -196,4 +196,9 @@
       cancellationTokenSource = new CancellationTokenSource();
       var interpreter = new IntervalInterpreter();
+      //!TODO:
+      //delete this
+      //IntervalConstraintsParser parser = new IntervalConstraintsParser();
+      //var parsed = parser.Parse((Content.ProblemData as RegressionProblemData).IntervalConstraintsParameter.Value.Value);
+      
 
       var impactAndReplacementValues = await Task.Run(() => CalculateImpactAndReplacementValues(tree));
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 16585)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/HeuristicLab.Problems.DataAnalysis.Views-3.4.csproj	(revision 16586)
@@ -518,4 +518,10 @@
     <Compile Include="Solution Views\TimeSeriesPrognosisSolutionView.Designer.cs">
       <DependentUpon>TimeSeriesPrognosisSolutionView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="TextValueView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="TextValueView.designer.cs">
+      <DependentUpon>TextValueView.cs</DependentUpon>
     </Compile>
     <Compile Include="TimeSeriesPrognosis\TimeSeriesPrognosisResidualsLineChartView.cs">
@@ -584,4 +590,7 @@
       <DependentUpon>NamedIntervalsView.cs</DependentUpon>
     </EmbeddedResource>
+    <EmbeddedResource Include="TextValueView.resx">
+      <DependentUpon>TextValueView.cs</DependentUpon>
+    </EmbeddedResource>
   </ItemGroup>
   <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/NamedIntervalsView.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/NamedIntervalsView.cs	(revision 16585)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/NamedIntervalsView.cs	(revision 16586)
@@ -65,5 +65,5 @@
       base.SetEnabledStateOfControls();
       dataGridView.Enabled = Content != null;
-      //dataGridView.ReadOnly = ReadOnly;
+      dataGridView.ReadOnly = ReadOnly;
     }
 
@@ -119,11 +119,9 @@
 
     private void dataGridView_CellValidating(object sender, DataGridViewCellValidatingEventArgs e) {
-      double value;
-
       if (dataGridView.Rows[e.RowIndex].IsNewRow) {
         return;
       }
 
-      if (!double.TryParse(e.FormattedValue.ToString(), out value)) {
+      if (!double.TryParse(e.FormattedValue.ToString(), out var value)) {
         e.Cancel = true;
         dataGridView.Rows[e.RowIndex].ErrorText = "Value must be a double value.";
@@ -135,5 +133,4 @@
         }
       }
-      
     }
 
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj	(revision 16585)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/HeuristicLab.Problems.DataAnalysis-3.4.csproj	(revision 16586)
@@ -175,4 +175,6 @@
     <Compile Include="Implementation\Interval.cs" />
     <Compile Include="Implementation\NamedIntervals.cs" />
+    <Compile Include="Implementation\Parser\IntervalConstraint.cs" />
+    <Compile Include="Implementation\Parser\IntervalConstraintsParser.cs" />
     <Compile Include="Implementation\Regression\ConfidenceBoundRegressionSolution.cs" />
     <Compile Include="Implementation\Regression\ConstantRegressionModel.cs" />
@@ -211,4 +213,5 @@
     <Compile Include="Interfaces\IDataset.cs" />
     <Compile Include="Interfaces\IDependencyCalculator.cs" />
+    <Compile Include="Interfaces\ITextValue.cs" />
     <Compile Include="Interfaces\ITransformation.cs" />
     <Compile Include="Interfaces\ITransformationMapper.cs" />
@@ -282,4 +285,5 @@
     <Compile Include="Implementation\Classification\ThresholdCalculators\NormalDistributionCutPointsThresholdCalculator.cs" />
     <Compile Include="Implementation\Classification\ThresholdCalculators\ThresholdCalculator.cs" />
+    <Compile Include="TextValue.cs" />
     <None Include="HeuristicLab.snk" />
     <None Include="Plugin.cs.frame" />
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/NamedIntervals.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/NamedIntervals.cs	(revision 16585)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/NamedIntervals.cs	(revision 16586)
@@ -15,7 +15,5 @@
   public class NamedIntervals : Item {   
     ObservableDictionary<string, Interval> variableIntervals = new ObservableDictionary<string, Interval>();
-    public ObservableDictionary<string, Interval> VariableIntervals {
-      get { return variableIntervals; }
-    }
+    public ObservableDictionary<string, Interval> VariableIntervals => variableIntervals;
 
     [Storable(Name = "StorableIntervalInformation")]
Index: /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs
===================================================================
--- /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 16585)
+++ /branches/2971_named_intervals/HeuristicLab.Problems.DataAnalysis/3.4/Implementation/Regression/RegressionProblemData.cs	(revision 16586)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using System.Linq;
+using System.Net.Mime;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -36,4 +37,5 @@
     protected const string TargetVariableParameterName = "TargetVariable";
     protected const string VariableRangesParameterName = "VariableRanges";
+    protected const string IntervalConstraintsParameterName = "IntervalConstraints";
     public string Filename { get; set; }
 
@@ -94,4 +96,5 @@
       problemData.Parameters.Add(new ConstrainedValueParameter<StringValue>(TargetVariableParameterName, new ItemSet<StringValue>()));
       problemData.Parameters.Add(new FixedValueParameter<NamedIntervals>(VariableRangesParameterName,"", new NamedIntervals()));
+      problemData.Parameters.Add(new FixedValueParameter<TextValue>(IntervalConstraintsParameterName, "", new TextValue()));
       emptyProblemData = problemData;
     }
@@ -105,4 +108,6 @@
       get { return (IFixedValueParameter<NamedIntervals>)Parameters[VariableRangesParameterName]; }
     }
+
+    public IFixedValueParameter<TextValue> IntervalConstraintsParameter => (IFixedValueParameter<TextValue>) Parameters[IntervalConstraintsParameterName];
 
     public string TargetVariable {
@@ -168,4 +173,5 @@
 
       Parameters.Add(new FixedValueParameter<NamedIntervals>(VariableRangesParameterName, namedIntervals));
+      Parameters.Add(new FixedValueParameter<TextValue>(IntervalConstraintsParameterName, new TextValue()));
       RegisterParameterEvents();
     }